<template>
  <div>
    <BaseFilter/>
    <v-row class="py-4 d-flex ">
      <v-col
        cols="12"
        sm="6"
        md="3"
        v-for="(person,index) of peopleList" :key="index"
      >
        <PeopleEntity class="justify-center" :person="person" :planet="getPlanetByPerson(person)"/>
      </v-col>
    </v-row>
  </div>
</template>

<script lang="ts">
import Vue from 'vue';
import BaseFilter from '~/components/BaseFilter/BaseFilter.vue';
import PeopleEntity from '~/components/PeopleEntity/PeopleEntity.vue';
import axios, {AxiosResponse} from 'axios';
import {ResultData, PersonData, PlanetData} from '~/types/types'
import {ref, useRoute, watch} from "@nuxtjs/composition-api";

export default Vue.extend({
  name: "PeopleLists",
  components: {BaseFilter, PeopleEntity},
  setup() {
    const route = useRoute()
    const peopleList = ref<PersonData[]>([]);
    const planetList = ref<PlanetData[]>([]);

    watch(route, (current) => {
      fetchPeopleData();
    })


    const fetchPeopleData = async () => {
      const filmFilter = route.value?.query?.film as string
      const responsePeople = await axios.get("https://swapi.dev/api/people/") as AxiosResponse<ResultData<PersonData>>;
      const responsePlanet = await axios.get("https://swapi.dev/api/planets/") as AxiosResponse<ResultData<PlanetData>>;
      peopleList.value = responsePeople.data.results.filter(x => filmFilter ? x.films.includes(filmFilter) : true)
      planetList.value = responsePlanet.data.results
    }

    const getPlanetByPerson = (person: PersonData) => {
      return planetList.value.find(p => p.url === person.homeworld)
    }

    fetchPeopleData()

    return {
      getPlanetByPerson,
      planetList,
      peopleList,
    }
  }
})


</script>

<style scoped>

</style>
